Translation(s): English - Español - Français - Italiano - Русский - 简体中文


NVIDIA Proprietary Driver

This page describes how to install the NVIDIA proprietary display driver on Debian systems.

Identification

The NVIDIA graphics processing unit (GPU) series/codename of an installed video card can usually be identified using the lspci command. For example:

See HowToIdentifyADevice/PCI for more information. The PCI ID can be used to verify device support.

Drivers

The proprietary "NVIDIA Accelerated Linux Graphics Driver" provides optimized hardware acceleration of OpenGL applications via a direct-rendering X server. It is a binary-only Xorg driver requiring a Linux kernel module for its use.

Three driver versions are available for Debian 7 "Wheezy":

Three driver versions are available for Debian 6.0 "Squeeze":

The 71.86.xx driver - supporting NVIDIA NV4/NV5/NV6/NV10/NV15 GPUs and variants - is not available, as this does not support Xorg X server versions later than 1.4 (620526, 708338).

All versions above are available only for the x86 and x86-64 architectures (Debian i386 and AMD64 ports respectively).

Installation

Debian 7 "Wheezy"

Version 304.88

For support of GeForce 6xxx and higher GPUs (supported devices). For older devices, see Version 173.14.35 (legacy GPUs) and Version 96.43.23 (legacy GPUs).

  1. Add "contrib" and "non-free" components to /etc/apt/sources.list, for example:

    # Debian 7 "Wheezy"
    deb http://http.debian.net/debian/ wheezy main contrib non-free
  2. Update the list of available packages. Install the appropriate linux-headers and kernel module packages:

    # aptitude update
    # aptitude -r install linux-headers-$(uname -r|sed 's,[^-]*-[^-]*-,,') nvidia-kernel-dkms

    This will also install the recommended nvidia-glx package. DKMS will build the nvidia module for your system.

  3. Create an Xorg server configuration file.

  4. Restart your system to enable the nouveau blacklist.

Version 173.14.35 (legacy GPUs)

For support of GeForce 5xxx / GeForce FX GPUs (supported devices).

  1. Add "contrib" and "non-free" components to /etc/apt/sources.list, for example:

    # Debian 7 "Wheezy"
    deb http://http.debian.net/debian/ wheezy main contrib non-free
  2. Update the list of available packages. Install the appropriate linux-headers and kernel module packages:

    # aptitude update
    # aptitude -r install linux-headers-$(uname -r|sed 's,[^-]*-[^-]*-,,') nvidia-kernel-legacy-173xx-dkms

    This will also install the recommended nvidia-glx-legacy-173xx package. DKMS will build the nvidia module for your system.

  3. Create an Xorg server configuration file.

  4. Restart your system to enable the nouveau blacklist.

Version 96.43.23 (legacy GPUs)

For support of GeForce 2, GeForce 3 and GeForce 4 GPUs (supported devices).

  1. Add "contrib" and "non-free" components to /etc/apt/sources.list, for example:

    # Debian 7 "Wheezy"
    deb http://http.debian.net/debian/ wheezy main contrib non-free
  2. Update the list of available packages. Install the appropriate linux-headers and kernel module packages:

    # aptitude update
    # aptitude -r install linux-headers-$(uname -r|sed 's,[^-]*-[^-]*-,,') nvidia-kernel-legacy-96xx-dkms

    This will also install the recommended nvidia-glx-legacy-96xx package. DKMS will build the nvidia module for your system.

  3. Create an Xorg server configuration file.

  4. Restart your system to enable the nouveau blacklist.

Debian 6.0 "Squeeze"

Version 195.36.31

For support of GeForce 6xxx and higher GPUs (supported devices), up to and including some GeForce 400 series devices. For older devices, see Version 173.14.27 (legacy GPUs) and Version 96.43.18 (legacy GPUs).

  1. Add "contrib" and "non-free" components to /etc/apt/sources.list, for example:

    # Debian 6.0 "Squeeze"
    deb http://http.debian.net/debian/ squeeze main contrib non-free
  2. Update the list of available packages. Install the appropriate linux-headers and kernel module packages:

    # aptitude update
    # aptitude -r install linux-headers-2.6-$(uname -r|sed 's,[^-]*-[^-]*-,,') nvidia-kernel-dkms

    This will also install the recommended nvidia-glx package. DKMS will build the nvidia module for your system.

  3. Update the initial ramdisk to include the nouveau blacklist (613951):

    # update-initramfs -u
  4. Create an Xorg server configuration file.

  5. Restart your system to enable the nouveau blacklist.

Version 173.14.27 (legacy GPUs)

For support of GeForce 5xxx / GeForce FX GPUs (supported devices).

  1. Add "contrib" and "non-free" components to /etc/apt/sources.list, for example:

    # Debian 6.0 "Squeeze"
    deb http://http.debian.net/debian/ squeeze main contrib non-free
  2. Update the list of available packages. Install the appropriate linux-headers and kernel module packages:

    # aptitude update
    # aptitude -r install linux-headers-2.6-$(uname -r|sed 's,[^-]*-[^-]*-,,') nvidia-kernel-legacy-173xx-dkms

    This will also install the recommended nvidia-glx-legacy-173xx package. DKMS will build the nvidia module for your system.

  3. Update the initial ramdisk to include the nouveau blacklist (613951):

    # update-initramfs -u
  4. Create an Xorg server configuration file.

  5. Restart your system to enable the nouveau blacklist.

Version 96.43.18 (legacy GPUs)

For support of GeForce 2, GeForce 3 and GeForce 4 GPUs (supported devices).

  1. Add "contrib" and "non-free" components to /etc/apt/sources.list, for example:

    # Debian 6.0 "Squeeze"
    deb http://http.debian.net/debian/ squeeze main contrib non-free
  2. Update the list of available packages. Install the appropriate linux-headers and kernel module packages:

    # aptitude update
    # aptitude -r install linux-headers-2.6-$(uname -r|sed 's,[^-]*-[^-]*-,,') nvidia-kernel-legacy-96xx-dkms

    This will also install the recommended nvidia-glx-legacy-96xx package. DKMS will build the nvidia module for your system.

  3. Update the initial ramdisk to include the nouveau blacklist (613951):

    # update-initramfs -u
  4. Create an Xorg server configuration file.

  5. Restart your system to enable the nouveau blacklist.

Configuration

As the nvidia driver is not autodetected by Xorg, a configuration file is required to be supplied. For example:

/etc/X11/xorg.conf.d/20-nvidia.conf

The configuration file above can be created using these commands:

Please note that this command will break your Xorg configuration on Optimus systems. For such hardware, see Bumblebee instead.

Restart your system at this point to enable the nouveau driver blacklist.

Extended Configuration, Stability & Performance

    Option         "NoLogo" "1"
    Option         "RenderAccel" "1"
    Option         "TripleBuffer" "true"
    Option         "MigrationHeuristic" "greedy"

in your homedirectory ~/.xinitrc should contain the below for a noticeable performance increase
nvidia-settings -a InitialPixmapPlacement=2 -a GlyphCache=1

GRUB_CMDLINE_LINUX_DEFAULT="quiet nomodeset enable_mtrr_cleanup mtrr_spare_reg_nr=4"

add nomodeset as a boot parameter ( grub, lilo or whatever you use ) 
nomodeset is critical for some nvidia cards and/or drivers

adding enable_mtrr_cleanup as a boot parameter ( grub, lilo or whatever you use )
in addition adding mtrr_spare_reg_nr=4 ( or a suitable number for your set-up ) will show improvements, take note the value=4 is hardware dependant.
one more important change code be setting NVreg_EnableMSI=0 and/or NVreg_Mobile ( mobile gfx cards only ) in /etc/modprobe.d/ for the nvidia module, which could read like ...

alias char-major-195* nvidia
options nvidia NVreg_DeviceFileUID=0 NVreg_DeviceFileGID=44 NVreg_DeviceFileMode=0660
options nvidia NVreg_EnableMSI=0
options nvidia NVreg_Mobile=1

Troubleshooting

See Also


CategoryProprietarySoftware